# Draw 1-p% Prediction Ellipses
pe <-
function(mm, vv=NULL, p=.99, col){
if(is.na(sum(mm))){return()}
if(is.null(vv))
vv=matrix(mm[(length(mm)/6*2+1):length(mm)],4)

mm=matrix(mm[1:(length(mm)/3)],2)

cols=RGB(c(0,1,2,3,4,1,2,3,4,2,3,4,3,4,4),0.5)

for(i in 1:ncol(mm)){

m=mm[,i]
v=matrix(vv[,i],2)

dd = 0.99
vinv=v
vinv[2:3]=-vinv[2:3]
vinv[1]=v[4]
vinv[4]=v[1]
vinv=vinv/det(v)
s=sqrt(diag(v))
l = eigen(vinv)$values
P = eigen(vinv)$vectors
a = -2*log(1-p)

Z=cbind(cos(0:200/100*pi)/sqrt(l[1]),sin(0:200/100*pi)/sqrt(l[2]))
Z=Z*sqrt(a)

Xs = t(P%*%t(Z)+m)
Xs = Xs[!is.na(Xs[,2]),]
Xs = rbind(Xs,Xs[1,])
polygon(Xs[,1],Xs[,2],col=cols[i],border=NA)
}
}

